"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from airbyte import utils
from dataclasses_json import Undefined, dataclass_json
from enum import Enum
from typing import Final, Optional, Union

class DestinationFireboltFirebolt(str, Enum):
    FIREBOLT = 'firebolt'

class DestinationFireboltLoadingMethodExternalTableViaS3Method(str, Enum):
    S3 = 'S3'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class DestinationFireboltLoadingMethodExternalTableViaS3:
    r"""Loading method used to select the way data will be uploaded to Firebolt"""
    aws_key_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('aws_key_id') }})
    r"""AWS access key granting read and write access to S3."""
    aws_key_secret: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('aws_key_secret') }})
    r"""Corresponding secret part of the AWS Key"""
    s3_bucket: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('s3_bucket') }})
    r"""The name of the S3 bucket."""
    s3_region: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('s3_region') }})
    r"""Region name of the S3 bucket."""
    METHOD: Final[DestinationFireboltLoadingMethodExternalTableViaS3Method] = dataclasses.field(default=DestinationFireboltLoadingMethodExternalTableViaS3Method.S3, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('method') }})
    


class DestinationFireboltLoadingMethodSQLInsertsMethod(str, Enum):
    SQL = 'SQL'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class DestinationFireboltLoadingMethodSQLInserts:
    r"""Loading method used to select the way data will be uploaded to Firebolt"""
    METHOD: Final[DestinationFireboltLoadingMethodSQLInsertsMethod] = dataclasses.field(default=DestinationFireboltLoadingMethodSQLInsertsMethod.SQL, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('method') }})
    



@dataclasses.dataclass
class DestinationFireboltLoadingMethod:
    pass


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class DestinationFirebolt:
    r"""The values required to configure the destination."""
    database: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('database') }})
    r"""The database to connect to."""
    password: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('password') }})
    r"""Firebolt password."""
    username: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('username') }})
    r"""Firebolt email address you use to login."""
    DESTINATION_TYPE: Final[DestinationFireboltFirebolt] = dataclasses.field(default=DestinationFireboltFirebolt.FIREBOLT, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('destinationType') }})
    account: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('account'), 'exclude': lambda f: f is None }})
    r"""Firebolt account to login."""
    engine: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('engine'), 'exclude': lambda f: f is None }})
    r"""Engine name or url to connect to."""
    host: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('host'), 'exclude': lambda f: f is None }})
    r"""The host name of your Firebolt database."""
    loading_method: Optional[Union[DestinationFireboltLoadingMethodSQLInserts, DestinationFireboltLoadingMethodExternalTableViaS3]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('loading_method'), 'exclude': lambda f: f is None }})
    r"""Loading method used to select the way data will be uploaded to Firebolt"""
    

